local YssDarkPact = {}
local YssDarkPact = LibStub("AceAddon-3.0"):NewAddon("YssDarkPact", "AceEvent-3.0", "LibSink-2.0")


local YDP_enable
local YDP_rank = 0
local YLT_enable
local YLT_rank = 0
local YLT_talent
local YDP_last_update = 0

local L_LTN = "Life Tap now!"
local L_DPN = "Dark Pact now!"
local l = GetLocale()

if l == "koKR" then
	local L_LTN = "Life Tap now!" --needs translation
	local L_DPN = "Dark Pact now!" --needs translation
elseif l == "frFR" then
	local L_LTN = "Life Tap now!" --needs translation
	local L_DPN = "Dark Pact now!" --needs translation
elseif l == "deDE" then
	local L_LTN = "Life Tap now!" --needs translation
	local L_DPN = "Dark Pact now!" --needs translation
elseif l == "zhCN" then
	local L_LTN = "Life Tap now!" --needs translation
	local L_DPN = "Dark Pact now!" --needs translation
elseif l == "zhTW" then
	local L_LTN = "Life Tap now!" --needs translation
	local L_DPN = "Dark Pact now!" --needs translation
elseif l == "ruRU" then
	local L_LTN = "Life Tap now!" --needs translation
	local L_DPN = "Dark Pact now!" --needs translation
end

function YssDarkPact:OnEnable()
	local _, Class = UnitClass("player")
	if Class == "WARLOCK" then
		YDP_DB = YDP_DB or {}
		local i = 1
		local _, _, offset, numSpells = GetSpellTabInfo(2);
		local DPspellids = {
			["18220"] = 305,
			["18937"] = 440,
			["18938"] = 545,
			["27265"] = 700,
		}
		local LTspellids = {
			["1454"] = 20,
			["1455"] = 65,
			["1456"] = 130,
			["11687"] = 210,
			["11688"] = 300,
			["11689"] = 420,
			["27222"] = 580,
		}
		for s = offset + 1, offset + numSpells do
			local suid = tostring(string.match(GetSpellLink(GetSpellName(s, BOOKTYPE_SPELL)), "spell:(%d+)"))
			if DPspellids[suid] and (DPspellids[suid] > YDP_rank) then
				YDP_enable = true
				YDP_rank = DPspellids[suid]
			end
			if LTspellids[suid] and (LTspellids[suid] > YLT_rank) then
				YLT_enable = true
				YLT_rank = LTspellids[suid]
			end
		end
		local _, _, _, _, currentRank = GetTalentInfo(1, 5)
		YLT_talent = ((currentRank * 10) + 100) / 100
		if YLT_enable then
			
					ICU:Print("UM")
			self:RegisterEvent("UNIT_MANA")
		end
		YDP_DB = YDP_DB or {}
		self:SetSinkStorage(YDP_DB)
		self.sinkoptions = self:GetSinkAce3OptionsDataTable()
		LibStub("AceConfig-3.0"):RegisterOptionsTable('YssDarkPactBlizzOptions', self.sinkoptions)
	    self.optframe = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YssDarkPactBlizzOptions", "YssDarkPact")
	end
end

function YssDarkPact:UNIT_MANA(event, arg1)
	ICU:Print(arg1)
	if arg1 == "pet" or arg1 == "player" then
		local YDP_stamp = GetTime()
		ICU:Print(YDP_stamp - YDP_last_update)
		if YDP_stamp - YDP_last_update > 5 then
			if not YDP_enable then
				if (UnitManaMax("player") - UnitMana("player") > (YLT_rank + (GetSpellBonusDamage(6) * .80)) * YLT_talent) and (UnitHealth("player") > UnitHealthMax("player")-UnitHealth("player")) and (UnitHealth("player") > YLT_rank + (GetSpellBonusDamage(6) * .80)) then
					self:Pour("Life Tap now!", 1, 0, 0, nil, 24, "OUTLINE", true)
					YDP_last_update = YDP_stamp
					ICU:Print("LT")
					return;
				end
			else
				if UnitManaMax("player") - UnitMana("player") > YDP_rank + (GetSpellBonusDamage(6) * .96) then
					if UnitMana("pet") >= YDP_rank + (GetSpellBonusDamage(6) * .96) then
						self:Pour("Dark Pact now!", 1, 0, 0, nil, 24, "OUTLINE", true)
						YDP_last_update = YDP_stamp
						ICU:Print("DP")
						return;
					else
						if (UnitManaMax("player") - UnitMana("player") > (YLT_rank + (GetSpellBonusDamage(6) * .80)) * YLT_talent) and (UnitHealth("player") > UnitHealthMax("player")-UnitHealth("player")) and (UnitHealth("player") > YLT_rank + (GetSpellBonusDamage(6) * .80)) then
							self:Pour("Life Tap now!", 1, 0, 0, nil, 24, "OUTLINE", true)
							YDP_last_update = YDP_stamp
							ICU:Print("LT")
							return;
						end
					end
				end
			end
		end
	end
end
